//+------------------------------------------------------------------+
//|                                           Brainwashing v0.1.mq4 |
//|                                        code by Alex.Piech.FinGeR |
//|                                        http://www.forex-tsd.com  |
//|                                                                  |
//| 20.10.2005  v.0.1 by Alex.Piech.FinGeR                           |
//|                                                                  |   
//+------------------------------------------------------------------+


#property copyright "Alex.Piech.FinGeR"
#property link      "http://www.forex-tsd.com"
#define   MAGIC      20051013

extern string PARAMETERS_TRADE = "PARAMETERS TRADE";
extern double Lots           = 0.1;    
extern int    StopLoss       = 10;     
extern int    TakeProfit     = 80;     

extern bool   useProfitTrailing = True;   
extern int    TrailingStop   = 20;   
extern int    TrailingStep   = 3;    
extern int    Slippage       = 3;   

extern string PARAMETERS_INDICATORS = "PriceChannel_Stop_v1";
extern int    CalcBackBars        = 0;
extern int    ChannelPeriod       = 9;    
extern double Risk                = 0.3; 
extern int    Nbars               = 1000;
//extern int  Signal=1;
//extern int  Line=1;

extern string PARAMETERS_EXPERT = "PARAMETERS EXPERT";
extern bool   UseOneAccount = False;    
extern int    NumberAccount = 0815;   
extern string Name_Expert   = "Brainwashing v0.1";
extern bool   UseSound      = True;         
extern string NameFileSound = "expert.wav"; 
extern color  clOpenBuy     = LightBlue;    
extern color  clOpenSell    = LightCoral;  
extern color  clModifyBuy   = Aqua;         
extern color  clModifySell  = Tomato;       
extern color  clCloseBuy    = Blue;         
extern color  clCloseSell   = Red;          

int prevBar; 


void deinit() 
{
  Comment("");
}


void start() {

Comment("");


 
 if (UseOneAccount && AccountNumber()!=NumberAccount) {
    Comment("-UseOnAccount- Number"+AccountNumber()+" FAILED!");
    return;
  } else Comment("");



  CheckForOpen();
   
  
 
   if (useProfitTrailing)  TrailingPositions();
}



void CheckForOpen() {
  double ldStop=0, ldTake=0;
  
  

 
double Buy=iCustom(NULL, 0, "PriceChannel_Stop_v1",ChannelPeriod,Risk,1,1,Nbars,0,CalcBackBars);

double Buy1=iCustom(NULL, 0, "PriceChannel_Stop_v1",ChannelPeriod,Risk,1,1,Nbars,3,CalcBackBars);
 
double Sell=iCustom(NULL, 0, "PriceChannel_Stop_v1",ChannelPeriod,Risk,1,1,Nbars,1,CalcBackBars);

double Sell1=iCustom(NULL, 0, "PriceChannel_Stop_v1",ChannelPeriod,Risk,1,1,Nbars,2,CalcBackBars);
  

  Comment(Buy,"fdgdfg",Sell);

  
  
    
  if (!ExistPosition() && prevBar!=Bars) {
    
   
       
    if (Sell==-1 && Sell1>-1) {
   
      if (StopLoss!=0) ldStop=Sell1-StopLoss*Point;
      if (TakeProfit!=0) ldTake=Ask+TakeProfit*Point;
      SetOrder(OP_BUY, Ask, ldStop, ldTake);
      prevBar=Bars;
    }
   
    if (Buy==-1 && Buy1>-1) {
    
      if (StopLoss!=0) ldStop=Buy1+StopLoss*Point;
      if (TakeProfit!=0) ldTake=Bid-TakeProfit*Point;
      SetOrder(OP_SELL, Bid, ldStop, ldTake);
      prevBar=Bars;
    }
  }
}



//+------------------------------------------------------------------+
//| is MAGIC trade open ?                                                 |
//+------------------------------------------------------------------+
bool ExistPosition() {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) Exist=True;
    }
  }
  return(Exist);
}




void SetOrder(int op, double pp, double ldStop, double ldTake) {
  color  clOpen;
  string lsComm=GetCommentForOrder();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
}





string GetCommentForOrder() {
  return(Name_Expert);
}





void TrailingPositions() {

  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
     
        if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC ) {
          if (OrderType()==OP_BUY) {
            if ((Bid-OrderOpenPrice())>TrailingStop*Point) {
             
              if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
                  ModifyStopLoss(Bid-TrailingStop*Point, clModifyBuy);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            if (OrderOpenPrice()-Ask>TrailingStop*Point) {
              if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
                ModifyStopLoss(Ask+TrailingStop*Point, clModifySell);
              }
            }
          }
        }
      }
    }
  }







void ModifyStopLoss(double ldStop, color clModify) {

  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();

  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
 
  if (fm && UseSound) PlaySound(NameFileSound);
}





// regards  
// Alex.Piech.FinGeR  
// big thanks KimIV 



